SystemOrganization addCategory: #'AL-Tests-Serialization'!

Object subclass: #ALObjectWithExternalState
	instanceVariableNames: 'alpha beta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Serialization'!

!ALObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2008 07:35'!
alpha
	^ alpha! !

!ALObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2008 07:35'!
beta
	^ beta! !

!ALObjectWithExternalState methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2012 21:34'!
initialize
	alpha := ValueHolder new
		contents: 'alpha';
		yourself.
	
	beta := ALReference new
		value: 'beta';
		yourself! !

TestCase subclass: #ALCodecTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Serialization'!

!ALCodecTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2012 21:34'!
testClassCaching
	| encoder stream first second |
	stream := ByteArray new writing.
	encoder := ALEncoder stream: stream.
	encoder encode: self class.
	first := stream position.
	encoder := encoder encode: self class.
	second := stream position.
	
	self assert: second < (first * 2).! !

!ALCodecTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2012 21:34'!
testClassIdentity
	| encoder stream first second decoder |
	stream := ByteArray new writing.
	encoder := ALEncoder stream: stream.
	encoder encode: self class.
	encoder encode: self class.
	
	stream := stream conclusion reading.
	decoder := ALDecoder stream: stream.
	first := decoder decode.
	second := decoder decode.
	self assert: first == self class.
	self assert: second == self class.! !

TestCase subclass: #ALEncoderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Serialization'!

!ALEncoderTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2012 21:34'!
isAbstract
	^ self name = #ALEncoderTest! !

!ALEncoderTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2008 23:49'!
assert: actual equals: expected
	| limit |
	limit := actual size min: expected size.
	1 to: limit do: [:index | self assert: (actual at: index) = (expected at: index)].
	self assert: actual size = expected size! !

!ALEncoderTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/6/2012 23:15'!
assert: anObject yields: expected 
	| stream actual |
	stream := ByteArray new writing.
	self encode: anObject on: stream.
	actual := stream contents.
	self 
		assert: actual
		equals: expected! !

!ALEncoderTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/6/2012 23:15'!
encode: anObject on: aStream
	self subclassResponsibility! !

!ALEncoderTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/23/2011 15:49'!
stringFromUnicode: anArray 
	| stringClass string |
	stringClass := (anArray anySatisfy: [:code | code > 255])
		ifTrue: [WideString]
		ifFalse: [ByteString].
	string := stringClass new: anArray size.
	1
		to: anArray size
		do:	[:index | 
			string
				at: index
				put: (Unicode value: (anArray at: index))].
	
	^ string! !

ALEncoderTest subclass: #ALUtf16EncoderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Serialization'!

!ALUtf16EncoderTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2012 21:34'!
encode: anObject on: aStream
	| encoder |
	encoder := ALEncoder stream: aStream.
	encoder encodeUtf16String: anObject.! !

!ALUtf16EncoderTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/23/2011 15:50'!
testAboriginal
	self 
		assert: (self stringFromUnicode: #(16r1401 16r1402 16r1403))
		yields: #[250 3 20 1 20 2 20 3]! !

!ALUtf16EncoderTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:26'!
testAscii
	self 
		assert: 'abc' 
		yields: #[250 3 0 97 0 98 0 99]! !

!ALUtf16EncoderTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/4/2011 15:35'!
testGClef
	self 
		assert: (self stringFromUnicode: #(16r1D11E))
		yields: #[250 1 216 52 221 30]
		
	! !

!ALUtf16EncoderTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/23/2011 15:50'!
testLatin
	self 
		assert: (self stringFromUnicode: #(225 98 99))
		yields: #[250 3 0 225 0 98 0 99]
	! !

ALEncoderTest subclass: #ALUtf8EncoderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Serialization'!

!ALUtf8EncoderTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2012 21:34'!
encode: anObject on: aStream
	| encoder |
	encoder := ALEncoder stream: aStream.
	encoder encodeUtf8String: anObject.! !

!ALUtf8EncoderTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/23/2011 15:50'!
testAboriginal
	self 
		assert: (self stringFromUnicode: #(16r1401 16r1402 16r1403))
		yields: #[251 3 225 144 129 225 144 130 225 144 131]! !

!ALUtf8EncoderTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/9/2010 20:24'!
testAscii
	self assert: 'abc' yields: #(251 3 97 98 99)! !

!ALUtf8EncoderTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/4/2011 16:06'!
testGClef
	self 
		assert: (self stringFromUnicode: #(16r1D11E))
		yields: #[251 1 240 157 132 158]
		
	! !

!ALUtf8EncoderTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/23/2011 15:50'!
testLatin
	self 
		assert: (self stringFromUnicode: #(225 98 99)) 
		yields: #[251 3 195 161 98 99]! !

TestCase subclass: #ALMaterializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Serialization'!

!ALMaterializerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2012 21:34'!
isAbstract
	^ self name = #ALMaterializerTest! !

!ALMaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2012 21:34'!
assert: aByteArray yields: expected
	| actual |
	actual := ALMaterializer materialize: aByteArray.
	self assert: actual = expected! !

!ALMaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:12'!
stringFromUnicode: anArray 
	| stringClass string |
	stringClass := (anArray anySatisfy: [:code | code > 255])
		ifTrue: [WideString]
		ifFalse: [ByteString].
	string := stringClass new: anArray size.
	1
		to: anArray size
		do:	[:index | 
			string
				at: index
				put: (Unicode value: (anArray at: index))].
	
	^ string! !

ALMaterializerTest subclass: #ALUtf16MaterializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Serialization'!

!ALUtf16MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:22'!
testAboriginal
	self
		assert: #[250 3 20 1 20 2 20 3]
		yields: (self stringFromUnicode: #(16r1401 16r1402 16r1403))! !

!ALUtf16MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:35'!
testAscii
	self
		assert: #[250 3 0 97 0 98 0 99]
		yields: 'abc'! !

!ALUtf16MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:35'!
testLatin
	self
		assert: #[250 3 0 225 0 98 0 99]
		yields: (self stringFromUnicode: #(225 98 99))! !

ALMaterializerTest subclass: #ALUtf8MaterializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Serialization'!

!ALUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:21'!
testAboriginal
	self
		assert: #[251 3 225 144 129 225 144 130 225 144 131]
		yields: (self stringFromUnicode: #(16r1401 16r1402 16r1403))! !

!ALUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:22'!
testAscii
	self
		assert: #[251 3 97 98 99]
		yields: 'abc'! !

!ALUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2011 11:14'!
testLatin
	self
		assert: #[251 3 195 161 98 99]
		yields: (self stringFromUnicode: #(225 98 99))! !

TestCase subclass: #ALReferenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Serialization'!

!ALReferenceTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2012 21:34'!
testCreationHolding
	| ref |
	ref := ALReference to: self.
	self assert: ref value == self! !

!ALReferenceTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2012 21:34'!
testIdentityPreservation
	| actual original one two |
	one := Object new.
	two := Object new.
	original := {ALReference to: one. ALReference to: two}.
	actual := original serialize materialize.
	self assert: actual first value == one.
	self assert: actual second value == two.! !

!ALReferenceTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2012 21:34'!
testValueHolding
	| ref |
	ref := ALReference to: nil.
	ref value: self.
	self assert: ref value == self! !

TestCase subclass: #ALRoundTripTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Serialization'!

!ALRoundTripTest methodsFor: 'support' stamp: 'cwp 9/2/2008 00:30'!
assertEqualityOf: expected
	^ self 
		assertEquivalenceOf: expected 
		with: [:actual | actual = expected]! !

!ALRoundTripTest methodsFor: 'support' stamp: 'cwp 9/5/2008 07:55'!
assertEquivalenceOf: expected with: aBlock
	self 
		examineResultOf: expected 
		with: 
			[:actual | 
			self assert: (aBlock value: actual)]! !

!ALRoundTripTest methodsFor: 'support' stamp: 'cwp 8/31/2008 23:00'!
assertIdentityOf: expected
	^ self
		assertEquivalenceOf: expected
		with: [:actual | actual == expected]! !

!ALRoundTripTest methodsFor: 'support' stamp: 'cwp 9/8/2008 21:17'!
examineResultOf: expected with: aBlock
	| actual archive |
	archive := expected serialize.
	actual := archive materialize.
	aBlock value: actual! !

!ALRoundTripTest methodsFor: 'support' stamp: 'cwp 8/7/2011 15:21'!
getContext
	^ thisContext! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/8/2008 19:13'!
testArchive
	| archive |
	archive := 3 serialize.
	self assert: archive materialize = 3! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 20:43'!
testArray
	self assertEqualityOf: #(1 'two' 3.0)! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 10/3/2011 15:12'!
testBag
	| bag |
	bag := Bag new.
	bag addAll: #(1 2 2 3).
	self assertEqualityOf: bag! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 19:24'!
testByte
	self assertEqualityOf: 42! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/10/2011 10:33'!
testByteArray
	| bytes |
	bytes := (0 to: 255) asByteArray.
	self assertEqualityOf: bytes! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 07:09'!
testBytesObject
	self assertEqualityOf: UUID new! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 23:02'!
testClass
	self assertIdentityOf: self class! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/23/2008 21:08'!
testCompiledMethod
	self assertIdentityOf: thisContext method.
	! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 19:57'!
testCyclicalReferenceArray
	| object |
	object := Array new: 1.
	object at: 1 put: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual first == actual]! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 20:06'!
testCyclicalReferenceDictionary
	| object |
	object := Dictionary new: 1.
	object at: #one put: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | (actual at: #one) == actual]! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 20:16'!
testCyclicalReferenceObject
	| object |
	object := ValueHolder new.
	object contents: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual contents == actual]! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/3/2008 19:58'!
testCyclicalReferenceSet
	| object |
	object := Set new: 1.
	object add: object.
	self 
		assertEquivalenceOf: object 
		with: [:actual | actual anyOne == actual]! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 22:22'!
testDictionary
	| dict |
	dict := Dictionary new
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3;
		yourself.
	self assertEqualityOf: dict! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 3/11/2012 21:39'!
testDigest
	| archive digest |
	archive := 3 serialize.
	digest := archive digest.
	self assert: digest = #[152 66 146 106 247 202 10 140 202 18 96 79 148 84 20 240 123 1 225 61]! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 3/11/2012 21:34'!
testExternalObject
	| object |
	object := ALObjectWithExternalState new.
	self 
		assertEquivalenceOf: object
		with: 
			[:actual |
			actual alpha ~~ object alpha
				and: [actual beta value == object beta value]]! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:34'!
testFalse
	self assertIdentityOf: false! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 19:50'!
testFloat
	self assertEqualityOf: 3.4! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/9/2011 14:53'!
testIdentity
	| a original |
	a := Object new.
	original := {a. a}.
	self 
		examineResultOf: original
		with: 
			[:result | 
			self deny: result == original.
			self deny: result first == a.
			self deny: result second == a.
			self assert: result first == result second]! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 10/3/2011 16:04'!
testIdentityDictionary
	| id |
	id := IdentityDictionary new.
	id at: #one put: 1.
	self 
		assertEquivalenceOf: id 
		with: 
			[ :actual | 
			actual class = id class.
			actual = id ]! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 10/3/2011 16:15'!
testInterval
	| interval |
	interval := 1 to: 10.
	self
		examineResultOf: interval
		with: 
			[ :actual | 
			self assert: actual class = interval class.
			self assert: actual = interval ]! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 17:28'!
testLargeNegativeInteger
	self assertEqualityOf: -65536! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 17:28'!
testLargePositiveInteger
	self assertEqualityOf: 65536! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 21:15'!
testLongString
	| string |
	string := String new: 300.
	string atAllPut: $a.
	self assertEqualityOf: string! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/7/2011 15:56'!
testMethodContext
	| original |
	original := self getContext.
	self examineResultOf: original with:   
		[:actual |
		self assert: original method == actual method.
		self assert: original sender isNil.
		self assert: original pc = actual pc.
		self assert: original method = actual method.
		self assert: original closure = actual closure.
		self assert: original receiver selector = actual receiver selector.
		self assert: original receiver timeoutForTest = actual receiver timeoutForTest].
		! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 21:59'!
testMultiString
	| ws |
	ws := WideString fromString: 'abc'.
	ws ifNotNil: [self assertEqualityOf: ws]! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:34'!
testNil
	self assertIdentityOf: nil! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 3/6/2012 18:03'!
testNilIdentityBug
	"This demonstrates a bug in the materializer. The serializer doesn't include nil in its internal 
	identity map, and the materializer shouldn't either."

	| array object |
	object := Object new.
	array := {nil. object. object}.
	self examineResultOf: array with:
		[:actual |
		self assert: actual first == nil.
		self deny: actual second == nil.
		self assert: actual second == actual third]! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 01:13'!
testObject
	self 
		assertEquivalenceOf: self 
		with: 
			[:actual |
			actual class = self class
				and: [actual selector = self selector]]! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 10/4/2011 11:26'!
testOrderedCollection
	self assertEqualityOf: #(1 'two' 3.0) asOrderedCollection! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 3/11/2012 21:34'!
testReference
	| expected |
	expected := ALReference to: self.
	self examineResultOf: expected with:
		[:actual |
		self deny: expected == actual.
		self assert: expected value == actual value]
	! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/2/2008 22:06'!
testSet
	self assertEqualityOf: #(1 'two' 3.0) asSet! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 16:52'!
testSmallNegativeInteger
	self assertEqualityOf: -300! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 16:52'!
testSmallPositiveInteger
	self assertEqualityOf: 300! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 8/31/2008 22:00'!
testString
	self assertEqualityOf: 'abc'.! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/9/2010 22:50'!
testStringWithAccent
	self assertEqualityOf: 'bc'.! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 00:04'!
testSymbol
	self assertIdentityOf: #one! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 2/16/2011 10:57'!
testTinyInteger
	self assertEqualityOf: 7! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 9/1/2008 19:26'!
testTrue
	self assertIdentityOf: true! !

!ALRoundTripTest methodsFor: 'tests' stamp: 'cwp 7/14/2010 11:04'!
testVariablePointerObject
	| expected |
	expected := (SparseLargeTable new: 3)
		at: 1 put: $a;
		at: 2 put: $b;
		at: 3 put: $c;
		yourself.

	self 
		assertEquivalenceOf: expected 
		with: 
			[:actual |
			actual class = expected class
				and: [actual = expected]]! !
